예제 #1
0
 /// <summary>
 /// Run sample Rooms
 /// </summary>
 public void Run()
 {
     try
     {
         //Get ProjectInfo object from current project
         Autodesk.Revit.DB.ProjectInfo projectInfo = m_doc.Document.ProjectInformation;
         if (null != projectInfo)
         {
             ProjectInfoForm mainForm = new ProjectInfoForm(new ProjectInfoWrapper(projectInfo));
             mainForm.ShowDialog();
         }
     }
     catch (Exception ex)
     {
         MessageBox.Show(ex.Message);
     }
 }
예제 #2
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            // initialize global information
            RevitStartInfo.RevitApp     = commandData.Application.Application;
            RevitStartInfo.RevitDoc     = commandData.Application.ActiveUIDocument.Document;
            RevitStartInfo.RevitProduct = commandData.Application.Application.Product;

            Transaction transaction = new Transaction(RevitStartInfo.RevitDoc, "ProjectInfo");

            try
            {
                // Start transaction
                transaction.Start();

                // get current project information
                Autodesk.Revit.DB.ProjectInfo pi = commandData.Application.ActiveUIDocument.Document.ProjectInformation;

                // show main form
                using (ProjectInfoForm pif = new ProjectInfoForm(new ProjectInfoWrapper(pi)))
                {
                    pif.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
                    if (pif.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    {
                        transaction.Commit();
                        return(Result.Succeeded);
                    }
                    else
                    {
                        transaction.RollBack();
                        return(Result.Cancelled);
                    }
                }
            }
            catch (Exception ex)
            {
                transaction.RollBack();
                message = ex.ToString();
                return(Result.Failed);
            }
        }
예제 #3
0
파일: Command.cs 프로젝트: AMEE/revit
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application 
        /// which contains data related to the command, 
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application 
        /// which will be displayed if a failure or cancellation is returned by 
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application 
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command. 
        /// A result of Succeeded means that the API external method functioned as expected. 
        /// Cancelled can be used to signify that the user cancelled the external operation 
        /// at some point. Failure should be returned if the application is unable to proceed with 
        /// the operation.</returns>
        public Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            // initialize global information
            RevitStartInfo.RevitApp = commandData.Application.Application;
            RevitStartInfo.RevitDoc = commandData.Application.ActiveUIDocument.Document;
            RevitStartInfo.RevitProduct = commandData.Application.Application.Product;

            Transaction transaction = new Transaction(RevitStartInfo.RevitDoc, "ProjectInfo");
            try
            {
                // Start transaction
                transaction.Start();

                // get current project information
                Autodesk.Revit.DB.ProjectInfo pi = commandData.Application.ActiveUIDocument.Document.ProjectInformation;

                // show main form
                using (ProjectInfoForm pif = new ProjectInfoForm(new ProjectInfoWrapper(pi)))
                {
                    pif.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
                    if (pif.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    {
                        transaction.Commit();
                        return Result.Succeeded;
                    }
                    else
                    {
                        transaction.RollBack();
                        return Result.Cancelled;
                    }
                }

            }
            catch (Exception ex)
            {
                transaction.RollBack();
                message = ex.ToString();
                return Result.Failed;
            }
        }